/* NBD client library in userspace
 * WARNING: THIS FILE IS GENERATED FROM
 * generator/generator
 * ANY CHANGES YOU MAKE TO THIS FILE WILL BE LOST.
 *
 * Copyright (C) 2013-2019 Red Hat Inc.
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
 */

#ifndef LIBNBD_H
#define LIBNBD_H

#include <stdbool.h>
#include <stdint.h>
#include <sys/socket.h>

struct nbd_handle;

#define LIBNBD_AIO_DIRECTION_READ  1
#define LIBNBD_AIO_DIRECTION_WRITE 2
#define LIBNBD_AIO_DIRECTION_BOTH  3

#define LIBNBD_CMD_FLAG_FUA        (1<<0)
#define LIBNBD_CMD_FLAG_NO_HOLE    (1<<1)
#define LIBNBD_CMD_FLAG_REQ_ONE    (1<<3)

extern struct nbd_handle *nbd_create (void);
extern void nbd_close (struct nbd_handle *h);
extern const char *nbd_get_error (void);
extern int nbd_get_errno (void);

extern int nbd_set_debug (struct nbd_handle *h, bool debug);
extern int nbd_get_debug (struct nbd_handle *h);
extern int nbd_set_debug_callback (struct nbd_handle *h, void *data, void (*debug_fn) (void *data, const char *context, const char *msg));
extern int nbd_set_export_name (struct nbd_handle *h, const char *export_name);
extern char *nbd_get_export_name (struct nbd_handle *h);
extern int nbd_set_tls (struct nbd_handle *h, int tls);
extern int nbd_get_tls (struct nbd_handle *h);
extern int nbd_set_tls_certificates (struct nbd_handle *h, const char *dir);
extern int nbd_set_tls_verify_peer (struct nbd_handle *h, bool verify);
extern int nbd_get_tls_verify_peer (struct nbd_handle *h);
extern int nbd_set_tls_username (struct nbd_handle *h, const char *username);
extern char *nbd_get_tls_username (struct nbd_handle *h);
extern int nbd_set_tls_psk_file (struct nbd_handle *h, const char *filename);
extern int nbd_request_meta_context (struct nbd_handle *h, const char *name);
extern int nbd_connect_unix (struct nbd_handle *h, const char *sockpath);
extern int nbd_connect_tcp (struct nbd_handle *h, const char *hostname, const char *port);
extern int nbd_connect_command (struct nbd_handle *h, char **argv);
extern int nbd_read_only (struct nbd_handle *h);
extern int nbd_can_flush (struct nbd_handle *h);
extern int nbd_can_fua (struct nbd_handle *h);
extern int nbd_is_rotational (struct nbd_handle *h);
extern int nbd_can_trim (struct nbd_handle *h);
extern int nbd_can_zero (struct nbd_handle *h);
extern int nbd_can_multi_conn (struct nbd_handle *h);
extern int nbd_can_cache (struct nbd_handle *h);
extern int nbd_can_meta_context (struct nbd_handle *h, const char *metacontext);
extern int64_t nbd_get_size (struct nbd_handle *h);
extern int nbd_pread (struct nbd_handle *h, void *buf, size_t count, uint64_t offset);
extern int nbd_pwrite (struct nbd_handle *h, const void *buf, size_t count, uint64_t offset, uint32_t flags);
extern int nbd_shutdown (struct nbd_handle *h);
extern int nbd_flush (struct nbd_handle *h);
extern int nbd_trim (struct nbd_handle *h, uint64_t count, uint64_t offset, uint32_t flags);
extern int nbd_cache (struct nbd_handle *h, uint64_t count, uint64_t offset);
extern int nbd_zero (struct nbd_handle *h, uint64_t count, uint64_t offset, uint32_t flags);
extern int nbd_block_status (struct nbd_handle *h, uint64_t count, uint64_t offset, uint32_t flags, void *data, void (*extent) (void *data, const char *metacontext, uint64_t offset, uint32_t *entries, size_t nr_entries));
extern int nbd_poll (struct nbd_handle *h, int timeout);
extern int nbd_aio_connect (struct nbd_handle *h, const struct sockaddr *addr, socklen_t addrlen);
extern int nbd_aio_connect_tcp (struct nbd_handle *h, const char *hostname, const char *port);
extern int nbd_aio_connect_command (struct nbd_handle *h, char **argv);
extern int64_t nbd_aio_pread (struct nbd_handle *h, void *buf, size_t count, uint64_t offset);
extern int64_t nbd_aio_pwrite (struct nbd_handle *h, const void *buf, size_t count, uint64_t offset, uint32_t flags);
extern int nbd_aio_disconnect (struct nbd_handle *h);
extern int64_t nbd_aio_flush (struct nbd_handle *h);
extern int64_t nbd_aio_trim (struct nbd_handle *h, uint64_t count, uint64_t offset, uint32_t flags);
extern int64_t nbd_aio_cache (struct nbd_handle *h, uint64_t count, uint64_t offset);
extern int64_t nbd_aio_zero (struct nbd_handle *h, uint64_t count, uint64_t offset, uint32_t flags);
extern int64_t nbd_aio_block_status (struct nbd_handle *h, uint64_t count, uint64_t offset, uint32_t flags, void *data, void (*extent) (void *data, const char *metacontext, uint64_t offset, uint32_t *entries, size_t nr_entries));
extern int nbd_aio_get_fd (struct nbd_handle *h);
extern int nbd_aio_get_direction (struct nbd_handle *h);
extern int nbd_aio_notify_read (struct nbd_handle *h);
extern int nbd_aio_notify_write (struct nbd_handle *h);
extern int nbd_aio_is_created (struct nbd_handle *h);
extern int nbd_aio_is_connecting (struct nbd_handle *h);
extern int nbd_aio_is_ready (struct nbd_handle *h);
extern int nbd_aio_is_processing (struct nbd_handle *h);
extern int nbd_aio_is_dead (struct nbd_handle *h);
extern int nbd_aio_is_closed (struct nbd_handle *h);
extern int nbd_aio_command_completed (struct nbd_handle *h, int64_t handle);
extern int64_t nbd_aio_peek_command_completed (struct nbd_handle *h);
extern const char *nbd_connection_state (struct nbd_handle *h);

#endif /* LIBNBD_H */
